DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Charts - Custom Annotations

Annotations are designed to show additional information about visualized data. You can display images, text blocks, and custom content in annotations. To create custom annotations, specify the following Chart properties.

en.wikipedia.org
Backend API
$(() => { $('#chart').dxChart({ dataSource: populationData, title: 'Top 5 Most Populated States in US', series: { type: 'bar', argumentField: 'name', valueField: 'population', name: 'Population', }, legend: { visible: false, }, commonAnnotationSettings: { type: 'custom', series: 'Population', allowDragging: true, template(annotation, container) { const { data } = annotation; const contentItems = ["<svg class='annotation'>", "<image href='../../../../images/flags/", data.name.replace(/\s/, ''), ".svg' width='60' height='40' />", "<rect class='border' x='0' y='0' />", "<text x='70' y='25' class='state'/>", "<text x='0' y='60'>", "<tspan class='caption'>Capital:</tspan>", "<tspan class='capital' dx='5'/>", "<tspan dy='14' x='0' class='caption'>Population:</tspan>", "<tspan class='population' dx='5'/>", "<tspan dy='14' x='0' class='caption'>Area:</tspan>", "<tspan class='area' dx='5'/>", "<tspan dx='5'>km</tspan><tspan dy='-2' class='sup'>2</tspan>", '</text></svg>']; const content = $(contentItems.join('')); content.find('.state').text(annotation.argument); content.find('.capital').text(data.capital); content.find('.population').text(formatNumber(data.population)); content.find('.area').text(formatNumber(data.area)); content.appendTo(container); }, }, annotations: $.map(populationData, (data) => ({ argument: data.name, data, })), }); }); const formatNumber = new Intl.NumberFormat('en-US', { maximumFractionDigits: 0 }).format;
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" /> <script src="js/dx.all.js?v=26.1.4"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="chart"></div> </div> </body> </html>
#chart { height: 440px; } .annotation { font-size: 12px; } .border { width: 60px; height: 40px; stroke: rgba(191, 191, 191, 0.25); stroke-width: 1px; fill: transparent; } .state { font-weight: 500; font-size: 14px; } .caption { font-weight: 500; } .sup { font-size: 0.8em; }
const populationData = [{ name: 'California', population: 38802500, capital: 'Sacramento', area: 423967, }, { name: 'Texas', population: 26956958, capital: 'Austin', area: 695662, }, { name: 'Florida', population: 19893297, capital: 'Tallahassee', area: 170312, }, { name: 'New York', population: 19746227, capital: 'Albany', area: 141297, }, { name: 'Illinois', population: 12880580, capital: 'Springfield', area: 149995, }];

annotations[]

The annotations array specifies a collection of annotations. This demo uses a data source array to create this collection. Each object has the argument property and a data object. The argument property positions an annotation at a specific argument, and the data object stores data from a data source.

You can use the annotations array to configure each annotation individually.

commonAnnotationSettings

Use the commonAnnotationSettings object to specify settings common to all annotations in the chart. In this object, assign custom to the type property. To anchor annotations to a series point, specify the series property. Finally, declare the SVG markup in the annotation template.

Note that individual annotation settings override the common annotation settings.

customizeAnnotation

You can also implement the customizeAnnotation function to customize an individual chart annotation.

<template>
<div>
<DxChart
id="chart"
:data-source="populationData"
title="Top 5 Most Populated States in US"
>
<DxSeries
type="bar"
argument-field="name"
value-field="population"
name="Population"
/>
<DxLegend
:visible="false"
/>
<DxCommonAnnotationSettings
:allow-dragging="true"
type="custom"
series="Population"
template="annotationTemplate"
/>
<DxAnnotation
v-for="data in populationData"
:argument="data.name"
:data="data"
:key="data.name"
/>
<template #annotationTemplate="{ data }">
<AnnotationTemplate :annotation="data"/>
</template>
</DxChart>
</div>
</template>
<script setup lang="ts">
import {
DxChart, DxSeries, DxLegend, DxAnnotation, DxCommonAnnotationSettings,
} from 'devextreme-vue/chart';
import { populationData } from './data.ts';
import AnnotationTemplate from './AnnotationTemplate.vue';
</script>
<style scoped>
#chart {
height: 440px;
}
</style>
<template>
<svg class="annotation">
<image
:href="getImagePath()"
width="60"
height="40"
/>
<rect
x="0"
y="0"
class="border"
/>
<text
x="70"
y="25"
class="state"
>{{ annotation.argument }}</text>
<text
x="0"
y="60"
>
<tspan class="caption">Capital:</tspan><tspan
class="capital"
dx="5"
>{{ data.capital }}</tspan><tspan
dy="14"
x="0"
class="caption"
>Population:</tspan><tspan
class="population"
dx="5"
>{{ formatNumber(data.population) }}</tspan><tspan
dy="14"
x="0"
class="caption"
>Area:</tspan><tspan
class="area"
dx="5"
>{{ formatNumber(data.area) }}</tspan><tspan dx="5">km</tspan><tspan
class="sup"
dy="-2"
>2</tspan>
</text>
</svg>
</template>
<script setup lang="ts">
import { ref } from 'vue';
interface Props {
annotation?: Record<string, any>;
}
const { annotation = {} as Record<string, any> } = defineProps<Props>();
const data = ref<Record<string, any>>(annotation.data);
const getImagePath = () => `../../../../images/flags/${data.value.name.replace(/\s/, '')}.svg`;
const formatNumber = new Intl.NumberFormat('en-US', { minimumFractionDigits: 0 }).format;
</script>
<style>
.annotation {
font-size: 12px;
}
.border {
width: 60px;
height: 40px;
stroke: rgba(191, 191, 191, 0.25);
stroke-width: 1px;
fill: transparent;
}
.state {
font-weight: 500;
font-size: 14px;
}
.caption {
font-weight: 500;
}
.sup {
font-size: 0.8em;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const populationData = [{
name: 'California',
population: 38802500,
capital: 'Sacramento',
area: 423967,
}, {
name: 'Texas',
population: 26956958,
capital: 'Austin',
area: 695662,
}, {
name: 'Florida',
population: 19893297,
capital: 'Tallahassee',
area: 170312,
}, {
name: 'New York',
population: 19746227,
capital: 'Albany',
area: 141297,
}, {
name: 'Illinois',
population: 12880580,
capital: 'Springfield',
area: 149995,
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

<dx-chart id="chart" [dataSource]="populationData">
<dxo-chart-title text="Top 5 Most Populated States in US"> </dxo-chart-title>
<dxi-chart-series
type="bar"
name="Population"
argumentField="name"
valueField="population"
>
</dxi-chart-series>
<dxo-chart-common-annotation-settings
type="custom"
series="Population"
template="template"
[allowDragging]="true"
>
</dxo-chart-common-annotation-settings>
@for(data of populationData; track data.name) {
<dxi-chart-annotation [data]="data" [argument]="data.name">
</dxi-chart-annotation>
}
<dxo-chart-legend [visible]="false"></dxo-chart-legend>
<svg *dxTemplate="let annotation of 'template'" class="annotation">
<image attr.href="{{ getImagePath(annotation) }}" width="60" height="40" />
<rect x="0" y="0" class="border" />
<text x="70" y="25" class="state">{{ annotation.argument }}</text>
<text x="0" y="60">
<tspan class="caption">Capital:</tspan>
<tspan class="capital" dx="5">{{ annotation.data.capital }}</tspan>
<tspan dy="14" x="0" class="caption">Population:</tspan>
<!-- display: inline -->
<tspan class="population" dx="5">{{
annotation.data.population | number : "3.0-0"
}}</tspan>
<tspan dy="14" x="0" class="caption">Area:</tspan>
<!-- display: inline -->
<tspan class="area" dx="5">{{
annotation.data.area | number : "3.0-0"
}}</tspan>
<tspan dx="5">km</tspan>
<tspan class="sup" dy="-2">2</tspan>
</text>
</svg>
</dx-chart>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DecimalPipe } from '@angular/common';
import { DxChartModule } from 'devextreme-angular';
import { Service, State } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxChartModule,
DecimalPipe,
],
})
export class AppComponent {
populationData: State[];
constructor(service: Service) {
this.populationData = service.getPopulationData();
}
getImagePath(annotation) {
const name = annotation.argument.replace(/\s/, '');
return `../../../../images/flags/${name}.svg`;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #chart {
height: 440px;
}
::ng-deep .annotation {
font-size: 12px;
}
::ng-deep .border {
width: 60px;
height: 40px;
stroke: rgba(191, 191, 191, 0.25);
stroke-width: 1px;
fill: transparent;
}
::ng-deep .state {
font-weight: 500;
font-size: 14px;
}
.caption {
font-weight: 500;
}
::ng-deep .sup {
font-size: 0.8em;
}
import { Injectable } from '@angular/core';
export interface State {
name: string;
population: number;
capital: string;
area: number;
}
const populationData: State[] = [{
name: 'California',
population: 38802500,
capital: 'Sacramento',
area: 423967,
}, {
name: 'Texas',
population: 26956958,
capital: 'Austin',
area: 695662,
}, {
name: 'Florida',
population: 19893297,
capital: 'Tallahassee',
area: 170312,
}, {
name: 'New York',
population: 19746227,
capital: 'Albany',
area: 141297,
}, {
name: 'Illinois',
population: 12880580,
capital: 'Springfield',
area: 149995,
}];
@Injectable()
export class Service {
getPopulationData(): State[] {
return populationData;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React from 'react';
import Chart, {
Series,
Annotation,
Legend,
CommonAnnotationSettings,
} from 'devextreme-react/chart';
import { populationData } from './data.ts';
import AnnotationTemplate from './AnnotationTemplate.tsx';
function App() {
return (
<Chart
id="chart"
dataSource={populationData}
title="Top 5 Most Populated States in US"
>
<Series
type="bar"
argumentField="name"
valueField="population"
name="Population"
>
</Series>
<CommonAnnotationSettings
type="custom"
series="Population"
render={AnnotationTemplate}
allowDragging={true}
>
</CommonAnnotationSettings>
{populationData.map((data) => (
<Annotation
argument={data.name}
key={data.name}
data={data}
>
</Annotation>
))}
<Legend visible={false}></Legend>
</Chart>
);
}
export default App;
import React from 'react';
import Chart, {
Series,
Annotation,
Legend,
CommonAnnotationSettings,
} from 'devextreme-react/chart';
import { populationData } from './data.js';
import AnnotationTemplate from './AnnotationTemplate.js';
function App() {
return (
<Chart
id="chart"
dataSource={populationData}
title="Top 5 Most Populated States in US"
>
<Series
type="bar"
argumentField="name"
valueField="population"
name="Population"
></Series>
<CommonAnnotationSettings
type="custom"
series="Population"
render={AnnotationTemplate}
allowDragging={true}
></CommonAnnotationSettings>
{populationData.map((data) => (
<Annotation
argument={data.name}
key={data.name}
data={data}
></Annotation>
))}
<Legend visible={false}></Legend>
</Chart>
);
}
export default App;
import React from 'react';
function getImagePath(data: { name: string; }) {
return `../../../../images/flags/${data.name.replace(/\s/, '')}.svg`;
}
const formatNumber = new Intl.NumberFormat('en-US', {
minimumFractionDigits: 0,
}).format;
interface AnnotationData {
name: string,
capital: string,
population: number,
area: number,
}
export default function AnnotationTemplate(annotation: { argument?: string; data?: AnnotationData; }) {
const { data } = annotation;
return (
<svg className="annotation">
<image href={getImagePath(data)} width="60" height="40" />
<rect x={0} y={0} className="border"></rect>
<text x="70" y="25" className="state">{annotation.argument}</text>
<text x="0" y="60">
<tspan className="caption">Capital:</tspan>
<tspan className="capital" dx="5">{data.capital}</tspan>
<tspan dy="14" x="0" className="caption">Population:</tspan>
<tspan className="population" dx="5">{formatNumber(data.population)}</tspan>
<tspan dy="14" x="0" className="caption">Area:</tspan>
<tspan className="area" dx="5">{formatNumber(data.area)}</tspan>
<tspan dx="5">km</tspan>
<tspan className="sup" dy="-2">2</tspan>
</text>
</svg>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const populationData = [{
name: 'California',
population: 38802500,
capital: 'Sacramento',
area: 423967,
}, {
name: 'Texas',
population: 26956958,
capital: 'Austin',
area: 695662,
}, {
name: 'Florida',
population: 19893297,
capital: 'Tallahassee',
area: 170312,
}, {
name: 'New York',
population: 19746227,
capital: 'Albany',
area: 141297,
}, {
name: 'Illinois',
population: 12880580,
capital: 'Springfield',
area: 149995,
}];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@24.1.7/cjs',
'devextreme-react': 'npm:devextreme-react@24.1.7/cjs',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.13/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.56/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.13',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.13/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
import React from 'react';
function getImagePath(data) {
return `../../../../images/flags/${data.name.replace(/\s/, '')}.svg`;
}
const formatNumber = new Intl.NumberFormat('en-US', {
minimumFractionDigits: 0,
}).format;
export default function AnnotationTemplate(annotation) {
const { data } = annotation;
return (
<svg className="annotation">
<image
href={getImagePath(data)}
width="60"
height="40"
/>
<rect
x={0}
y={0}
className="border"
></rect>
<text
x="70"
y="25"
className="state"
>
{annotation.argument}
</text>
<text
x="0"
y="60"
>
<tspan className="caption">Capital:</tspan>
<tspan
className="capital"
dx="5"
>
{data.capital}
</tspan>
<tspan
dy="14"
x="0"
className="caption"
>
Population:
</tspan>
<tspan
className="population"
dx="5"
>
{formatNumber(data.population)}
</tspan>
<tspan
dy="14"
x="0"
className="caption"
>
Area:
</tspan>
<tspan
className="area"
dx="5"
>
{formatNumber(data.area)}
</tspan>
<tspan dx="5">km</tspan>
<tspan
className="sup"
dy="-2"
>
2
</tspan>
</text>
</svg>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const populationData = [
{
name: 'California',
population: 38802500,
capital: 'Sacramento',
area: 423967,
},
{
name: 'Texas',
population: 26956958,
capital: 'Austin',
area: 695662,
},
{
name: 'Florida',
population: 19893297,
capital: 'Tallahassee',
area: 170312,
},
{
name: 'New York',
population: 19746227,
capital: 'Albany',
area: 141297,
},
{
name: 'Illinois',
population: 12880580,
capital: 'Springfield',
area: 149995,
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.1.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#chart {
height: 440px;
}
.annotation {
font-size: 12px;
}
.border {
width: 60px;
height: 40px;
stroke: rgba(191, 191, 191, 0.25);
stroke-width: 1px;
fill: transparent;
}
.state {
font-weight: 500;
font-size: 14px;
}
.caption {
font-weight: 500;
}
.sup {
font-size: 0.8em;
}